<?php

class onIformsChangePubDate extends cmsAction {

	public function run($data = array()){

		$core = cmsCore::getInstance();
		$request = $core->request->getAll();

		if (empty($request['ctype_name']) || empty($request['slug'])){return false;}

		$user = cmsUser::getInstance();
		$content_model = cmsCore::getModel('content');

		$item = $content_model->getContentItemBySlug($request['ctype_name'], $request['slug']);
		if (!$item){return false;}

		if (!cmsUser::isAdmin()){ // если пользователь - админ, то списание средств не нужно.
			if ($user->id !== $item['user_id']){return false;}

			$billing = cmsCore::isControllerExists('billing') ? cmsCore::getController('billing') : false;

			$amount = 30; // тут указывается сумма, которая будет списана при нажатии на кнопку. Если хотите управлять этим полем из биллинга, то поставьте здесь 0.

			if ($billing && $amount > 0){
				// проверяем ьекущий баланс пользователя
				$balance = cmsUser::get('balance');
				if ($balance < $amount){
					// тут можно изменить фразу о недостаточности средств.
					cmsUser::addSessionMessage('Недостаточно средств. Пополните баланс.', 'error');
					return false;
				}

				$description = array(
					'text' => 'Поднятие в списке - ' . $item['title'], // тут текст для истории платежей в биллинге.
					'url' => href_to($request['ctype_name'], $request['slug'].'.html') // тут ссылка на саму запись.
				);

				$billing->decrementUserBalance($user->id, $amount, $description);
			}
		}

		$result = $content_model->update($content_model->table_prefix . $request['ctype_name'], $item['id'], array(
			'date_pub' => null,
			'date_last_modified' => null
		));

		if ($result){
			// тут можно изменить фразу об успешности провеления операции.
			cmsUser::addSessionMessage('Дата публикации этой записи обновлена', 'success');
		} else {
			// тут можно изменить фразу о проблемах при обновлении даты.
			cmsUser::addSessionMessage('Возникли технические проблемы с обновлением даты публикации этой записи. Попробуйте позже.', 'info');
		}
		return false;
	}
}